Name:		ocaml
Version:	3.01
Release: 2mdk
Summary:	The Objective Caml compiler and programming environment
Source0:	ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}.tar.bz2
Source1:	ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}-refman.html.tar.bz2
Source2:	ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}-refman.ps.bz2
Source3:	ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}-refman.info.tar.bz2
Source4:	%{name}.menu
Patch0: ocaml-3.00-camldebug_el.patch.bz2
Patch1: ocaml-3.01-info.patch.bz2
Patch2: ocaml-3.00-bad-define-bcopy.patch.bz2
Patch3: ocaml-3.00-ocamltags--no-site-start.patch.bz2
Copyright:	QPL & LGPL
Group:		Development/Other
BuildRequires: XFree86-devel gpm-devel ncurses-devel tcl tk
URL:		http://caml.inria.fr/
Packager:       Pixel <pixel@mandrakesoft.com>
BuildRoot:	%{_tmppath}/ocaml-root
Obsoletes:	ocamltk ocaml-emacs

%description
Objective Caml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler and an
optimizing native-code compiler), an interactive toplevel system, Lex&Yacc
tools, a replay debugger, and a comprehensive library.

%prep

%setup -T -b 0
%setup -T -D -a 1
%setup -T -D -a 3
%patch0 -p1

gunzip infoman/ocaml.info.gz
%patch1 -p1
#%patch2 -p1
%patch3 -p1

%build
%ifarch alpha
echo %{optflags} | grep -q mieee || { echo "on alpha you need -mieee to compile ocaml"; exit 1; }
%endif

./configure -bindir %{_bindir} -libdir %{_libdir}/ocaml -mandir %{_mandir}/man1

flag=$(echo %{optflags} | sed 's/-fomit-frame-pointer//')
make BYTECCCOMPOPTS="$flag -fno-defer-pop" NATIVECCCOMPOPTS="$flag" world opt ocamlc.opt ocamlopt.opt

%install
rm -rf $RPM_BUILD_ROOT

echo BINDIR=$RPM_BUILD_ROOT%{_bindir} >> config/Makefile
echo LIBDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml >> config/Makefile
echo MANDIR=$RPM_BUILD_ROOT%{_mandir}/man1 >> config/Makefile
make install installopt

install -d $RPM_BUILD_ROOT%{_infodir} $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
(cd emacs; make install install-ocamltags EMACSDIR=$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp)
(cd infoman; cp -f ocaml* $RPM_BUILD_ROOT%{_infodir})

install -d $RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d
cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d/%{name}.el
(autoload 'caml-mode "caml" "Caml editing mode" t)
(add-hook 'caml-mode-hook 'font-lock-mode)
(add-to-list 'auto-mode-alist '("\\\\.mli?$" . caml-mode))
EOF

install -d $RPM_BUILD_ROOT%{_menudir}
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_menudir}/%{name}

export EXCLUDE_FROM_STRIP="ocamldebug ocamlbrowser"

%clean
rm -rf ${RPM_BUILD_ROOT}

%post 
%_install_info %{name}.info

%preun
%_remove_install_info %{name}.info

%files
%defattr(-,root,root)
%doc Changes LICENSE README htmlman/* 
%{_bindir}/*
%{_libdir}/ocaml
%{_infodir}/*
%{_mandir}/man1/*
#%{_menudir}/*
%{_datadir}/emacs/site-lisp/*
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/*

%changelog
* Sun Mar 25 2001 Pixel <pixel@mandrakesoft.com> 3.01-2mdk
- oops, forgot the info patch

* Thu Mar 22 2001 Pixel <pixel@mandrakesoft.com> 3.01-1mdk
- new version

* Mon Mar 19 2001 Pixel <pixel@mandrakesoft.com> 3.00-25mdk
- fix the ocaml.el (\\. -> \\\\.)

* Tue Dec 12 2000 Pixel <pixel@mandrakesoft.com> 3.00-24mdk
- ocamltags--no-site-start.patch

* Thu Nov  2 2000 Pixel <pixel@mandrakesoft.com> 3.00-23mdk
- fix silly #define clashing with new glibc

* Tue Oct 10 2000 Pixel <pixel@mandrakesoft.com> 3.00-22mdk
- add ocamltags (needs emacs)

* Mon Sep  4 2000 Pixel <pixel@mandrakesoft.com> 3.00-21mdk
- rebuild with spec-helper fixed

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-20mdk
- fix info pages

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-19mdk
- remove menu entry

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-18mdk
- add packager

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-17mdk
- add obsolete %{name}-emacs

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-16mdk
- nicer site-start.d/ocaml.el (use add-to-list)

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-15mdk
- fix missing %%config, add install info

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-14mdk
- use %{_sysconfdir}/emacs/site-start.d for the caml-mode.el
- merge %{name} and %{name}-emacs

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.00-13mdk
- automatically added BuildRequires

* Tue Aug 01 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.00-12mdk
- relink with the new and shiny tcltk

* Wed Jul 26 2000 Pixel <pixel@mandrakesoft.com> 3.00-11mdk
- use %%{optflags} with omit-frame-buffer removed

* Tue Jul 25 2000 Pixel <pixel@mandrakesoft.com> 3.00-10mdk
- use %%{optflags} (so that there is -mieee on alpha)

* Sat Jul 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-9mdk
- patch for camldebug.el to workaround the silly ocamldebug command not looking
in cwd

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-7mdk
- more macro (use clean clean_menus)

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-6mdk
- macroization
- BM

* Sun Jun 04 2000 David BAUDENS <baudens@mandrakesoft.com> 3.00-5mdk
- Fix %%{doc}
- Use %%{_tmppath} for BuildRoot

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-4mdk
- change copyright

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-3mdk
- takes care of ocamlbrowser and ocamldebug (these must not be stripped)

* Tue May 16 2000 Pixel <pixel@mandrakesoft.com> 3.00-2mdk
- add README to ocaml-emacs

* Mon May  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-1mdk
- new version

* Mon Apr 10 2000 Pixel <pixel@mandrakesoft.com> 2.04-9mdk
- fix groups

* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 2.04-8mdk
- really add menu

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 2.04-7mdk
- add menu

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 2.04-6mdk
- new group + cleanup

* Mon Dec  6 1999 Pixel <pixel@linux-mandrake.com>
- 2.04

* Fri Nov 26 1999 Pixel <pixel@linux-mandrake.com>
- 2.03 + cleanup

* Tue Nov 23 1999 Pixel <pixel@linux-mandrake.com>
- build root added

* Tue Jun 01 1999 Pixel <pixel@linux-mandrake.com>
- Hacked to package properly ocamltk

* Tue Dec 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Do not include any /usr/lib/ocaml/*.ml files

* Fri Dec 11 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to ocaml-2.01

* Sun Nov 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Divided ocaml RPM into ocaml and ocaml-emacs RPMs 
  to make it easier to have both ocaml and caml installed
  on the same machine

* Wed Nov 10 1998 Alexey Nogin <ayn2@cornell.edu>
- Changed SRPM according to RHCN Package Requirements
- Added LICENSE, Changelog and README files to the doc directory
